package cmd

import (
	"fmt"

	flags "github.com/orus-io/go-flags"

	"orus.io/orus-io/rednerd/restapi"
)

// VersionCmd is the "version" command.
type VersionCmd struct{}

// Execute the 'version' commands.
func (cmd *VersionCmd) Execute([]string) error {
	fmt.Println("Rednerd " + restapi.GetVersion())

	return nil
}

// AddToParser adds the command to the given parser.
func (cmd *VersionCmd) AddToParser(parser *flags.Parser) error {
	_, err := parser.AddCommand("version", "Print the program version", "", cmd)
	if err != nil {
		return err
	}

	return nil
}
