// This file is generated by 'gendbfiles' - DO NOT EDIT

package models

// This file contains constants for all db names involved in a mapped struct
// It also add some accessors on the struct types so they implement a 'Mapped' interface

import (
	"github.com/Masterminds/squirrel"
	"orus.io/orus-io/go-orusapi/database"
)

// Mapped is the common interface of all structs that are mapped in the database
type Mapped interface {
	Table() string
	PKeyColumn() string
	Columns(withPKey bool) []string
	Values(columns ...string) []interface{}
	ValuesMap(columns ...string) map[string]interface{}
}

type TableSchema interface {
	GetName() string
	Sql() string
}

func NewColumn(table TableSchema, name string) Column {
	return Column{table, name, ""}
}

type Column struct {
	table TableSchema
	name string
	alias string
}

func (c Column) Sql() string {
	sql :=  c.table.GetName()+"."+c.name
	if c.alias != "" {
		sql += " AS " + c.alias
	}
	return sql
}

func (c Column) ToSql() (string, []interface{}, error ) {
	return c.Sql(), nil, nil
}

func (c Column) Join(col Column) Join {
	return Join{
		from: c,
		to: col,
	}
}

func (c Column) Eq(value interface{}) squirrel.Eq{
	return squirrel.Eq{c.Sql(): value}
}

func (c Column) Ne(value interface{}) squirrel.NotEq{
	return squirrel.NotEq{c.Sql(): value}
}

func (c Column) Gt(value interface{}) squirrel.Gt{
	return squirrel.Gt{c.Sql(): value}
}

func (c Column) Gte(value interface{}) squirrel.GtOrEq{
	return squirrel.GtOrEq{c.Sql(): value}
}

func (c Column) Lt(value interface{}) squirrel.Lt{
	return squirrel.Lt{c.Sql(): value}
}

func (c Column) Lte(value interface{}) squirrel.LtOrEq{
	return squirrel.LtOrEq{c.Sql(): value}
}

func (c Column) Like(value interface{}) squirrel.Like{
	return squirrel.Like{c.Sql(): value}
}

func (c Column) NotLike(value interface{}) squirrel.NotLike{
	return squirrel.NotLike{c.Sql(): value}
}

func (c Column) ArrayContains(value interface{}) database.ArrayContains{
	return database.ArrayContains{c.Sql(): value}
}

func (c Column) As(name string) Column {
	c.alias = name
	return c
}

func (c Column) Name() string {
	if c.alias != "" {
		return c.alias
	}
	return c.table.GetName() + "." + c.name
}

func (c Column) ColName() string {
	return c.name
}

type Join struct {
	from Column
	to Column
}

func (j Join) Sql() string {
	return j.to.table.Sql() + " ON " + j.to.Sql() + " = " + j.from.Sql()
}


const (
	// table and column names

	// AccountDBTable is the name of the table where AccountDB are stored
	AccountDBTable = "account"

	// AccountDBPKeyColumn is the name of the primary key
	AccountDBPKeyColumn = AccountDBNameColumn

	// AccountDBNameColumn is the name of the column containing field "Name" data
	AccountDBNameColumn = "name"

	// AccountDBIsUserColumn is the name of the column containing field "IsUser" data
	AccountDBIsUserColumn = "is_user"

	// ApikeyDescriptionColumn is the name of the column containing field "Description" data
	ApikeyDescriptionColumn = "description"

	// ApikeyNameColumn is the name of the column containing field "Name" data
	ApikeyNameColumn = "name"

	// ApikeyAndValueDescriptionColumn is the name of the column containing field "Description" data
	ApikeyAndValueDescriptionColumn = "description"

	// ApikeyAndValueNameColumn is the name of the column containing field "Name" data
	ApikeyAndValueNameColumn = "name"

	// ApikeyAndValueValueColumn is the name of the column containing field "Value" data
	ApikeyAndValueValueColumn = "value"

	// ApikeyDBTable is the name of the table where ApikeyDB are stored
	ApikeyDBTable = "users_apikey"

	// ApikeyDBPKeyColumn is the name of the primary key
	ApikeyDBPKeyColumn = ApikeyDBIDColumn

	// ApikeyDBDescriptionColumn is the name of the column containing field "Description" data
	ApikeyDBDescriptionColumn = "description"

	// ApikeyDBNameColumn is the name of the column containing field "Name" data
	ApikeyDBNameColumn = "name"

	// ApikeyDBValueColumn is the name of the column containing field "Value" data
	ApikeyDBValueColumn = "value"

	// ApikeyDBIDColumn is the name of the column containing field "ID" data
	ApikeyDBIDColumn = "id"

	// ApikeyDBUsernameColumn is the name of the column containing field "Username" data
	ApikeyDBUsernameColumn = "username"

	// EmailTable is the name of the table where Email are stored
	EmailTable = "email_queue"

	// EmailPKeyColumn is the name of the primary key
	EmailPKeyColumn = EmailIDColumn

	// EmailIDColumn is the name of the column containing field "ID" data
	EmailIDColumn = "id"

	// EmailCreatedAtColumn is the name of the column containing field "CreatedAt" data
	EmailCreatedAtColumn = "created_at"

	// EmailFromColumn is the name of the column containing field "From" data
	EmailFromColumn = "from_"

	// EmailToColumn is the name of the column containing field "To" data
	EmailToColumn = "to_"

	// EmailMsgColumn is the name of the column containing field "Msg" data
	EmailMsgColumn = "msg"

	// EmailStatusChangedColumn is the name of the column containing field "StatusChanged" data
	EmailStatusChangedColumn = "status_changed"

	// EmailStatusColumn is the name of the column containing field "Status" data
	EmailStatusColumn = "status"

	// EmailLastErrorColumn is the name of the column containing field "LastError" data
	EmailLastErrorColumn = "last_error"

	// EmailAttemptsColumn is the name of the column containing field "Attempts" data
	EmailAttemptsColumn = "attempts"

	// EmailReattemptAtColumn is the name of the column containing field "ReattemptAt" data
	EmailReattemptAtColumn = "reattempt_at"

	// RegistrationEmailColumn is the name of the column containing field "Email" data
	RegistrationEmailColumn = "email"

	// RegistrationFirstnameColumn is the name of the column containing field "Firstname" data
	RegistrationFirstnameColumn = "firstname"

	// RegistrationLastnameColumn is the name of the column containing field "Lastname" data
	RegistrationLastnameColumn = "lastname"

	// RenderLogTable is the name of the table where RenderLog are stored
	RenderLogTable = "render_logs"

	// RenderLogPKeyColumn is the name of the primary key
	RenderLogPKeyColumn = RenderLogIDColumn

	// RenderLogIDColumn is the name of the column containing field "ID" data
	RenderLogIDColumn = "id"

	// RenderLogRenderedAtColumn is the name of the column containing field "RenderedAt" data
	RenderLogRenderedAtColumn = "rendered_at"

	// RenderLogDurationColumn is the name of the column containing field "Duration" data
	RenderLogDurationColumn = "duration"

	// RenderLogFromTypeColumn is the name of the column containing field "FromType" data
	RenderLogFromTypeColumn = "from_type"

	// RenderLogToTypeColumn is the name of the column containing field "ToType" data
	RenderLogToTypeColumn = "to_type"

	// RenderLogUsernameColumn is the name of the column containing field "Username" data
	RenderLogUsernameColumn = "username"

	// RenderLogPipelineStepsColumn is the name of the column containing field "PipelineSteps" data
	RenderLogPipelineStepsColumn = "pipeline_steps"

	// RenderLogTemplateIDColumn is the name of the column containing field "TemplateID" data
	RenderLogTemplateIDColumn = "template_id"

	// RenderLogTemplateInternalVersionColumn is the name of the column containing field "TemplateInternalVersion" data
	RenderLogTemplateInternalVersionColumn = "template_internal_version"

	// RenderLogTemplateLanguageColumn is the name of the column containing field "TemplateLanguage" data
	RenderLogTemplateLanguageColumn = "template_language"

	// RenderLogDebugQueryColumn is the name of the column containing field "DebugQuery" data
	RenderLogDebugQueryColumn = "debug_query"

	// ResetPasswordTokenDBTable is the name of the table where ResetPasswordTokenDB are stored
	ResetPasswordTokenDBTable = "reset_password_token"

	// ResetPasswordTokenDBPKeyColumn is the name of the primary key
	ResetPasswordTokenDBPKeyColumn = ResetPasswordTokenDBTokenColumn

	// ResetPasswordTokenDBUsernameColumn is the name of the column containing field "Username" data
	ResetPasswordTokenDBUsernameColumn = "username"

	// ResetPasswordTokenDBCreatedAtColumn is the name of the column containing field "CreatedAt" data
	ResetPasswordTokenDBCreatedAtColumn = "created_at"

	// ResetPasswordTokenDBTokenColumn is the name of the column containing field "Token" data
	ResetPasswordTokenDBTokenColumn = "token"

	// TemplateAccountColumn is the name of the column containing field "Account" data
	TemplateAccountColumn = "account"

	// TemplateCreatedAtColumn is the name of the column containing field "CreatedAt" data
	TemplateCreatedAtColumn = "created_at"

	// TemplateDataSchemaColumn is the name of the column containing field "DataSchema" data
	TemplateDataSchemaColumn = "data_schema"

	// TemplateDescriptionColumn is the name of the column containing field "Description" data
	TemplateDescriptionColumn = "description"

	// TemplateLanguageColumn is the name of the column containing field "Language" data
	TemplateLanguageColumn = "language"

	// TemplateLocaleColumn is the name of the column containing field "Locale" data
	TemplateLocaleColumn = "locale"

	// TemplateMetadataColumn is the name of the column containing field "Metadata" data
	TemplateMetadataColumn = "metadata"

	// TemplateNameColumn is the name of the column containing field "Name" data
	TemplateNameColumn = "name"

	// TemplateProducesColumn is the name of the column containing field "Produces" data
	TemplateProducesColumn = "produces"

	// TemplateStaticMetadataColumn is the name of the column containing field "StaticMetadata" data
	TemplateStaticMetadataColumn = "static_metadata"

	// TemplateTitleColumn is the name of the column containing field "Title" data
	TemplateTitleColumn = "title"

	// TemplateVersionColumn is the name of the column containing field "Version" data
	TemplateVersionColumn = "version"

	// TemplateDBTable is the name of the table where TemplateDB are stored
	TemplateDBTable = "template"

	// TemplateDBPKeyColumn is the name of the primary key
	TemplateDBPKeyColumn = TemplateDBIDColumn

	// TemplateDBAccountColumn is the name of the column containing field "Account" data
	TemplateDBAccountColumn = "account"

	// TemplateDBCreatedAtColumn is the name of the column containing field "CreatedAt" data
	TemplateDBCreatedAtColumn = "created_at"

	// TemplateDBDataSchemaColumn is the name of the column containing field "DataSchema" data
	TemplateDBDataSchemaColumn = "data_schema"

	// TemplateDBDescriptionColumn is the name of the column containing field "Description" data
	TemplateDBDescriptionColumn = "description"

	// TemplateDBLanguageColumn is the name of the column containing field "Language" data
	TemplateDBLanguageColumn = "language"

	// TemplateDBLocaleColumn is the name of the column containing field "Locale" data
	TemplateDBLocaleColumn = "locale"

	// TemplateDBMetadataColumn is the name of the column containing field "Metadata" data
	TemplateDBMetadataColumn = "metadata"

	// TemplateDBNameColumn is the name of the column containing field "Name" data
	TemplateDBNameColumn = "name"

	// TemplateDBProducesColumn is the name of the column containing field "Produces" data
	TemplateDBProducesColumn = "produces"

	// TemplateDBStaticMetadataColumn is the name of the column containing field "StaticMetadata" data
	TemplateDBStaticMetadataColumn = "static_metadata"

	// TemplateDBTitleColumn is the name of the column containing field "Title" data
	TemplateDBTitleColumn = "title"

	// TemplateDBVersionColumn is the name of the column containing field "Version" data
	TemplateDBVersionColumn = "version"

	// TemplateDBIDColumn is the name of the column containing field "ID" data
	TemplateDBIDColumn = "id"

	// TemplateDBInternalVersionColumn is the name of the column containing field "InternalVersion" data
	TemplateDBInternalVersionColumn = "internal_version"

	// TemplateDBETagColumn is the name of the column containing field "ETag" data
	TemplateDBETagColumn = "etag"

	// TemplateDBBytesBodyColumn is the name of the column containing field "BytesBody" data
	TemplateDBBytesBodyColumn = "body"

	// UserDBTable is the name of the table where UserDB are stored
	UserDBTable = "users"

	// UserDBPKeyColumn is the name of the primary key
	UserDBPKeyColumn = UserDBUsernameColumn

	// UserDBCreatedAtColumn is the name of the column containing field "CreatedAt" data
	UserDBCreatedAtColumn = "created_at"

	// UserDBEmailColumn is the name of the column containing field "Email" data
	UserDBEmailColumn = "email"

	// UserDBEnableRequestLoggingColumn is the name of the column containing field "EnableRequestLogging" data
	UserDBEnableRequestLoggingColumn = "enable_request_logging"

	// UserDBFirstnameColumn is the name of the column containing field "Firstname" data
	UserDBFirstnameColumn = "firstname"

	// UserDBIsAdminColumn is the name of the column containing field "IsAdmin" data
	UserDBIsAdminColumn = "is_admin"

	// UserDBLastnameColumn is the name of the column containing field "Lastname" data
	UserDBLastnameColumn = "lastname"

	// UserDBUsernameColumn is the name of the column containing field "Username" data
	UserDBUsernameColumn = "username"

	// UserDBPasswordColumn is the name of the column containing field "Password" data
	UserDBPasswordColumn = "password"

	// UserinfoCreatedAtColumn is the name of the column containing field "CreatedAt" data
	UserinfoCreatedAtColumn = "created_at"

	// UserinfoEmailColumn is the name of the column containing field "Email" data
	UserinfoEmailColumn = "email"

	// UserinfoEnableRequestLoggingColumn is the name of the column containing field "EnableRequestLogging" data
	UserinfoEnableRequestLoggingColumn = "enable_request_logging"

	// UserinfoFirstnameColumn is the name of the column containing field "Firstname" data
	UserinfoFirstnameColumn = "firstname"

	// UserinfoIsAdminColumn is the name of the column containing field "IsAdmin" data
	UserinfoIsAdminColumn = "is_admin"

	// UserinfoLastnameColumn is the name of the column containing field "Lastname" data
	UserinfoLastnameColumn = "lastname"

	// UserinfoUsernameColumn is the name of the column containing field "Username" data
	UserinfoUsernameColumn = "username"
)

var (
	// DBAllTables is the list of all the database table names
	DBAllTables = []string{
		AccountDBTable,
		ApikeyDBTable,
		EmailTable,
		RenderLogTable,
		ResetPasswordTokenDBTable,
		TemplateDBTable,
		UserDBTable,
	}
	// AccountDBDataColumns is the list of the columns for the AccountDB structure, expect its primary key
	AccountDBDataColumns = []string{
		AccountDBIsUserColumn,
	}

	// AccountDBColumns is the list of the columns for the AccountDB structure
	AccountDBColumns = append(
		[]string{ AccountDBNameColumn },
		AccountDBDataColumns...,
	)
	// ApikeyColumns is the list of the columns for the Apikey structure
	ApikeyColumns = []string{
		ApikeyDescriptionColumn,
		ApikeyNameColumn,
	}
	// ApikeyAndValueColumns is the list of the columns for the ApikeyAndValue structure
	ApikeyAndValueColumns = []string{
		ApikeyAndValueDescriptionColumn,
		ApikeyAndValueNameColumn,
		ApikeyAndValueValueColumn,
	}
	// ApikeyDBDataColumns is the list of the columns for the ApikeyDB structure, expect its primary key
	ApikeyDBDataColumns = []string{
		ApikeyDBDescriptionColumn,
		ApikeyDBNameColumn,
		ApikeyDBValueColumn,
		ApikeyDBUsernameColumn,
	}

	// ApikeyDBColumns is the list of the columns for the ApikeyDB structure
	ApikeyDBColumns = append(
		[]string{ ApikeyDBIDColumn },
		ApikeyDBDataColumns...,
	)
	// EmailDataColumns is the list of the columns for the Email structure, expect its primary key
	EmailDataColumns = []string{
		EmailCreatedAtColumn,
		EmailFromColumn,
		EmailToColumn,
		EmailMsgColumn,
		EmailStatusChangedColumn,
		EmailStatusColumn,
		EmailLastErrorColumn,
		EmailAttemptsColumn,
		EmailReattemptAtColumn,
	}

	// EmailColumns is the list of the columns for the Email structure
	EmailColumns = append(
		[]string{ EmailIDColumn },
		EmailDataColumns...,
	)
	// RegistrationColumns is the list of the columns for the Registration structure
	RegistrationColumns = []string{
		RegistrationEmailColumn,
		RegistrationFirstnameColumn,
		RegistrationLastnameColumn,
	}
	// RenderLogDataColumns is the list of the columns for the RenderLog structure, expect its primary key
	RenderLogDataColumns = []string{
		RenderLogRenderedAtColumn,
		RenderLogDurationColumn,
		RenderLogFromTypeColumn,
		RenderLogToTypeColumn,
		RenderLogUsernameColumn,
		RenderLogPipelineStepsColumn,
		RenderLogTemplateIDColumn,
		RenderLogTemplateInternalVersionColumn,
		RenderLogTemplateLanguageColumn,
		RenderLogDebugQueryColumn,
	}

	// RenderLogColumns is the list of the columns for the RenderLog structure
	RenderLogColumns = append(
		[]string{ RenderLogIDColumn },
		RenderLogDataColumns...,
	)
	// ResetPasswordTokenDBDataColumns is the list of the columns for the ResetPasswordTokenDB structure, expect its primary key
	ResetPasswordTokenDBDataColumns = []string{
		ResetPasswordTokenDBUsernameColumn,
		ResetPasswordTokenDBCreatedAtColumn,
	}

	// ResetPasswordTokenDBColumns is the list of the columns for the ResetPasswordTokenDB structure
	ResetPasswordTokenDBColumns = append(
		[]string{ ResetPasswordTokenDBTokenColumn },
		ResetPasswordTokenDBDataColumns...,
	)
	// TemplateColumns is the list of the columns for the Template structure
	TemplateColumns = []string{
		TemplateAccountColumn,
		TemplateCreatedAtColumn,
		TemplateDataSchemaColumn,
		TemplateDescriptionColumn,
		TemplateLanguageColumn,
		TemplateLocaleColumn,
		TemplateMetadataColumn,
		TemplateNameColumn,
		TemplateProducesColumn,
		TemplateStaticMetadataColumn,
		TemplateTitleColumn,
		TemplateVersionColumn,
	}
	// TemplateDBDataColumns is the list of the columns for the TemplateDB structure, expect its primary key
	TemplateDBDataColumns = []string{
		TemplateDBAccountColumn,
		TemplateDBCreatedAtColumn,
		TemplateDBDataSchemaColumn,
		TemplateDBDescriptionColumn,
		TemplateDBLanguageColumn,
		TemplateDBLocaleColumn,
		TemplateDBMetadataColumn,
		TemplateDBNameColumn,
		TemplateDBProducesColumn,
		TemplateDBStaticMetadataColumn,
		TemplateDBTitleColumn,
		TemplateDBVersionColumn,
		TemplateDBInternalVersionColumn,
		TemplateDBETagColumn,
		TemplateDBBytesBodyColumn,
	}

	// TemplateDBColumns is the list of the columns for the TemplateDB structure
	TemplateDBColumns = append(
		[]string{ TemplateDBIDColumn },
		TemplateDBDataColumns...,
	)
	// UserDBDataColumns is the list of the columns for the UserDB structure, expect its primary key
	UserDBDataColumns = []string{
		UserDBCreatedAtColumn,
		UserDBEmailColumn,
		UserDBEnableRequestLoggingColumn,
		UserDBFirstnameColumn,
		UserDBIsAdminColumn,
		UserDBLastnameColumn,
		UserDBPasswordColumn,
	}

	// UserDBColumns is the list of the columns for the UserDB structure
	UserDBColumns = append(
		[]string{ UserDBUsernameColumn },
		UserDBDataColumns...,
	)
	// UserinfoColumns is the list of the columns for the Userinfo structure
	UserinfoColumns = []string{
		UserinfoCreatedAtColumn,
		UserinfoEmailColumn,
		UserinfoEnableRequestLoggingColumn,
		UserinfoFirstnameColumn,
		UserinfoIsAdminColumn,
		UserinfoLastnameColumn,
		UserinfoUsernameColumn,
	}
)

// Table returns the database table name
func (s AccountDB) Table() string {
	return AccountDBTable
}

// PKeyColumn returns the database table primary key column name
func (s AccountDB) PKeyColumn() string {
	return AccountDBPKeyColumn
}

// Columns returns the database table column names
func (s AccountDB) Columns(withPKey bool) []string {
	if withPKey {
		return AccountDBColumns
	}
	return AccountDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s AccountDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "name":
			values[i] = s.Name
		case "is_user":
			values[i] = s.IsUser
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s AccountDB) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "name":
			values["name"] = s.Name
		case "is_user":
			values["is_user"] = s.IsUser
		}
	}
	return values
}

func NewAccountDBTableSchema() *AccountDBTableSchema {
	t := AccountDBTableSchema{}
	t.Name = NewColumn(&t, "name")
	t.IsUser = NewColumn(&t, "is_user")
	return &t
}

type AccountDBTableSchema struct {
	alias string
	Name Column
	IsUser Column
}

// Columns returns the database table column names
func (t AccountDBTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return AccountDBColumns
	}
	return AccountDBDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t AccountDBTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = AccountDBDataColumns

	if withPKey {
		colList = AccountDBColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t AccountDBTableSchema) As(name string) *AccountDBTableSchema {
	t.alias = name
	t.Name = NewColumn(&t, "name")
	t.IsUser = NewColumn(&t, "is_user")
	return &t
}

func (t AccountDBTableSchema) GetName() string {
	if t.alias == "" {
		return AccountDBTable
	}
	return t.alias
}

func (t AccountDBTableSchema) Sql() string {
	if t.alias == "" {
		return AccountDBTable
	}
	return AccountDBTable + " AS " + t.alias
}

func (t AccountDBTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t AccountDBTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Columns returns the database table column names
func (s Apikey) Columns() []string {
	return ApikeyColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Apikey) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "description":
			values[i] = s.Description
		case "name":
			values[i] = s.Name
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s Apikey) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "description":
			values["description"] = s.Description
		case "name":
			values["name"] = s.Name
		}
	}
	return values
}

// Columns returns the database table column names
func (s ApikeyAndValue) Columns() []string {
	return ApikeyAndValueColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s ApikeyAndValue) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "description":
			values[i] = s.Description
		case "name":
			values[i] = s.Name
		case "value":
			values[i] = s.Value
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s ApikeyAndValue) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "description":
			values["description"] = s.Description
		case "name":
			values["name"] = s.Name
		case "value":
			values["value"] = s.Value
		}
	}
	return values
}

// Table returns the database table name
func (s ApikeyDB) Table() string {
	return ApikeyDBTable
}

// PKeyColumn returns the database table primary key column name
func (s ApikeyDB) PKeyColumn() string {
	return ApikeyDBPKeyColumn
}

// Columns returns the database table column names
func (s ApikeyDB) Columns(withPKey bool) []string {
	if withPKey {
		return ApikeyDBColumns
	}
	return ApikeyDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s ApikeyDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "description":
			values[i] = s.Description
		case "name":
			values[i] = s.Name
		case "value":
			values[i] = s.Value
		case "id":
			values[i] = s.ID
		case "username":
			values[i] = s.Username
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s ApikeyDB) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "description":
			values["description"] = s.Description
		case "name":
			values["name"] = s.Name
		case "value":
			values["value"] = s.Value
		case "id":
			values["id"] = s.ID
		case "username":
			values["username"] = s.Username
		}
	}
	return values
}

func NewApikeyDBTableSchema() *ApikeyDBTableSchema {
	t := ApikeyDBTableSchema{}
	t.Description = NewColumn(&t, "description")
	t.Name = NewColumn(&t, "name")
	t.Value = NewColumn(&t, "value")
	t.ID = NewColumn(&t, "id")
	t.Username = NewColumn(&t, "username")
	return &t
}

type ApikeyDBTableSchema struct {
	alias string
	Description Column
	Name Column
	Value Column
	ID Column
	Username Column
}

// Columns returns the database table column names
func (t ApikeyDBTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return ApikeyDBColumns
	}
	return ApikeyDBDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t ApikeyDBTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = ApikeyDBDataColumns

	if withPKey {
		colList = ApikeyDBColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t ApikeyDBTableSchema) As(name string) *ApikeyDBTableSchema {
	t.alias = name
	t.Description = NewColumn(&t, "description")
	t.Name = NewColumn(&t, "name")
	t.Value = NewColumn(&t, "value")
	t.ID = NewColumn(&t, "id")
	t.Username = NewColumn(&t, "username")
	return &t
}

func (t ApikeyDBTableSchema) GetName() string {
	if t.alias == "" {
		return ApikeyDBTable
	}
	return t.alias
}

func (t ApikeyDBTableSchema) Sql() string {
	if t.alias == "" {
		return ApikeyDBTable
	}
	return ApikeyDBTable + " AS " + t.alias
}

func (t ApikeyDBTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t ApikeyDBTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Table returns the database table name
func (s Email) Table() string {
	return EmailTable
}

// PKeyColumn returns the database table primary key column name
func (s Email) PKeyColumn() string {
	return EmailPKeyColumn
}

// Columns returns the database table column names
func (s Email) Columns(withPKey bool) []string {
	if withPKey {
		return EmailColumns
	}
	return EmailDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Email) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "id":
			values[i] = s.ID
		case "created_at":
			values[i] = s.CreatedAt
		case "from_":
			values[i] = s.From
		case "to_":
			values[i] = s.To
		case "msg":
			values[i] = s.Msg
		case "status_changed":
			values[i] = s.StatusChanged
		case "status":
			values[i] = s.Status
		case "last_error":
			values[i] = s.LastError
		case "attempts":
			values[i] = s.Attempts
		case "reattempt_at":
			values[i] = s.ReattemptAt
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s Email) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "id":
			values["id"] = s.ID
		case "created_at":
			values["created_at"] = s.CreatedAt
		case "from_":
			values["from_"] = s.From
		case "to_":
			values["to_"] = s.To
		case "msg":
			values["msg"] = s.Msg
		case "status_changed":
			values["status_changed"] = s.StatusChanged
		case "status":
			values["status"] = s.Status
		case "last_error":
			values["last_error"] = s.LastError
		case "attempts":
			values["attempts"] = s.Attempts
		case "reattempt_at":
			values["reattempt_at"] = s.ReattemptAt
		}
	}
	return values
}

func NewEmailTableSchema() *EmailTableSchema {
	t := EmailTableSchema{}
	t.ID = NewColumn(&t, "id")
	t.CreatedAt = NewColumn(&t, "created_at")
	t.From = NewColumn(&t, "from_")
	t.To = NewColumn(&t, "to_")
	t.Msg = NewColumn(&t, "msg")
	t.StatusChanged = NewColumn(&t, "status_changed")
	t.Status = NewColumn(&t, "status")
	t.LastError = NewColumn(&t, "last_error")
	t.Attempts = NewColumn(&t, "attempts")
	t.ReattemptAt = NewColumn(&t, "reattempt_at")
	return &t
}

type EmailTableSchema struct {
	alias string
	ID Column
	CreatedAt Column
	From Column
	To Column
	Msg Column
	StatusChanged Column
	Status Column
	LastError Column
	Attempts Column
	ReattemptAt Column
}

// Columns returns the database table column names
func (t EmailTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return EmailColumns
	}
	return EmailDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t EmailTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = EmailDataColumns

	if withPKey {
		colList = EmailColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t EmailTableSchema) As(name string) *EmailTableSchema {
	t.alias = name
	t.ID = NewColumn(&t, "id")
	t.CreatedAt = NewColumn(&t, "created_at")
	t.From = NewColumn(&t, "from_")
	t.To = NewColumn(&t, "to_")
	t.Msg = NewColumn(&t, "msg")
	t.StatusChanged = NewColumn(&t, "status_changed")
	t.Status = NewColumn(&t, "status")
	t.LastError = NewColumn(&t, "last_error")
	t.Attempts = NewColumn(&t, "attempts")
	t.ReattemptAt = NewColumn(&t, "reattempt_at")
	return &t
}

func (t EmailTableSchema) GetName() string {
	if t.alias == "" {
		return EmailTable
	}
	return t.alias
}

func (t EmailTableSchema) Sql() string {
	if t.alias == "" {
		return EmailTable
	}
	return EmailTable + " AS " + t.alias
}

func (t EmailTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t EmailTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Columns returns the database table column names
func (s Registration) Columns() []string {
	return RegistrationColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Registration) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "email":
			values[i] = s.Email
		case "firstname":
			values[i] = s.Firstname
		case "lastname":
			values[i] = s.Lastname
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s Registration) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "email":
			values["email"] = s.Email
		case "firstname":
			values["firstname"] = s.Firstname
		case "lastname":
			values["lastname"] = s.Lastname
		}
	}
	return values
}

// Table returns the database table name
func (s RenderLog) Table() string {
	return RenderLogTable
}

// PKeyColumn returns the database table primary key column name
func (s RenderLog) PKeyColumn() string {
	return RenderLogPKeyColumn
}

// Columns returns the database table column names
func (s RenderLog) Columns(withPKey bool) []string {
	if withPKey {
		return RenderLogColumns
	}
	return RenderLogDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s RenderLog) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "id":
			values[i] = s.ID
		case "rendered_at":
			values[i] = s.RenderedAt
		case "duration":
			values[i] = s.Duration
		case "from_type":
			values[i] = s.FromType
		case "to_type":
			values[i] = s.ToType
		case "username":
			values[i] = s.Username
		case "pipeline_steps":
			values[i] = s.PipelineSteps
		case "template_id":
			values[i] = s.TemplateID
		case "template_internal_version":
			values[i] = s.TemplateInternalVersion
		case "template_language":
			values[i] = s.TemplateLanguage
		case "debug_query":
			values[i] = s.DebugQuery
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s RenderLog) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "id":
			values["id"] = s.ID
		case "rendered_at":
			values["rendered_at"] = s.RenderedAt
		case "duration":
			values["duration"] = s.Duration
		case "from_type":
			values["from_type"] = s.FromType
		case "to_type":
			values["to_type"] = s.ToType
		case "username":
			values["username"] = s.Username
		case "pipeline_steps":
			values["pipeline_steps"] = s.PipelineSteps
		case "template_id":
			values["template_id"] = s.TemplateID
		case "template_internal_version":
			values["template_internal_version"] = s.TemplateInternalVersion
		case "template_language":
			values["template_language"] = s.TemplateLanguage
		case "debug_query":
			values["debug_query"] = s.DebugQuery
		}
	}
	return values
}

func NewRenderLogTableSchema() *RenderLogTableSchema {
	t := RenderLogTableSchema{}
	t.ID = NewColumn(&t, "id")
	t.RenderedAt = NewColumn(&t, "rendered_at")
	t.Duration = NewColumn(&t, "duration")
	t.FromType = NewColumn(&t, "from_type")
	t.ToType = NewColumn(&t, "to_type")
	t.Username = NewColumn(&t, "username")
	t.PipelineSteps = NewColumn(&t, "pipeline_steps")
	t.TemplateID = NewColumn(&t, "template_id")
	t.TemplateInternalVersion = NewColumn(&t, "template_internal_version")
	t.TemplateLanguage = NewColumn(&t, "template_language")
	t.DebugQuery = NewColumn(&t, "debug_query")
	return &t
}

type RenderLogTableSchema struct {
	alias string
	ID Column
	RenderedAt Column
	Duration Column
	FromType Column
	ToType Column
	Username Column
	PipelineSteps Column
	TemplateID Column
	TemplateInternalVersion Column
	TemplateLanguage Column
	DebugQuery Column
}

// Columns returns the database table column names
func (t RenderLogTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return RenderLogColumns
	}
	return RenderLogDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t RenderLogTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = RenderLogDataColumns

	if withPKey {
		colList = RenderLogColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t RenderLogTableSchema) As(name string) *RenderLogTableSchema {
	t.alias = name
	t.ID = NewColumn(&t, "id")
	t.RenderedAt = NewColumn(&t, "rendered_at")
	t.Duration = NewColumn(&t, "duration")
	t.FromType = NewColumn(&t, "from_type")
	t.ToType = NewColumn(&t, "to_type")
	t.Username = NewColumn(&t, "username")
	t.PipelineSteps = NewColumn(&t, "pipeline_steps")
	t.TemplateID = NewColumn(&t, "template_id")
	t.TemplateInternalVersion = NewColumn(&t, "template_internal_version")
	t.TemplateLanguage = NewColumn(&t, "template_language")
	t.DebugQuery = NewColumn(&t, "debug_query")
	return &t
}

func (t RenderLogTableSchema) GetName() string {
	if t.alias == "" {
		return RenderLogTable
	}
	return t.alias
}

func (t RenderLogTableSchema) Sql() string {
	if t.alias == "" {
		return RenderLogTable
	}
	return RenderLogTable + " AS " + t.alias
}

func (t RenderLogTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t RenderLogTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Table returns the database table name
func (s ResetPasswordTokenDB) Table() string {
	return ResetPasswordTokenDBTable
}

// PKeyColumn returns the database table primary key column name
func (s ResetPasswordTokenDB) PKeyColumn() string {
	return ResetPasswordTokenDBPKeyColumn
}

// Columns returns the database table column names
func (s ResetPasswordTokenDB) Columns(withPKey bool) []string {
	if withPKey {
		return ResetPasswordTokenDBColumns
	}
	return ResetPasswordTokenDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s ResetPasswordTokenDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "username":
			values[i] = s.Username
		case "created_at":
			values[i] = s.CreatedAt
		case "token":
			values[i] = s.Token
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s ResetPasswordTokenDB) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "username":
			values["username"] = s.Username
		case "created_at":
			values["created_at"] = s.CreatedAt
		case "token":
			values["token"] = s.Token
		}
	}
	return values
}

func NewResetPasswordTokenDBTableSchema() *ResetPasswordTokenDBTableSchema {
	t := ResetPasswordTokenDBTableSchema{}
	t.Username = NewColumn(&t, "username")
	t.CreatedAt = NewColumn(&t, "created_at")
	t.Token = NewColumn(&t, "token")
	return &t
}

type ResetPasswordTokenDBTableSchema struct {
	alias string
	Username Column
	CreatedAt Column
	Token Column
}

// Columns returns the database table column names
func (t ResetPasswordTokenDBTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return ResetPasswordTokenDBColumns
	}
	return ResetPasswordTokenDBDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t ResetPasswordTokenDBTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = ResetPasswordTokenDBDataColumns

	if withPKey {
		colList = ResetPasswordTokenDBColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t ResetPasswordTokenDBTableSchema) As(name string) *ResetPasswordTokenDBTableSchema {
	t.alias = name
	t.Username = NewColumn(&t, "username")
	t.CreatedAt = NewColumn(&t, "created_at")
	t.Token = NewColumn(&t, "token")
	return &t
}

func (t ResetPasswordTokenDBTableSchema) GetName() string {
	if t.alias == "" {
		return ResetPasswordTokenDBTable
	}
	return t.alias
}

func (t ResetPasswordTokenDBTableSchema) Sql() string {
	if t.alias == "" {
		return ResetPasswordTokenDBTable
	}
	return ResetPasswordTokenDBTable + " AS " + t.alias
}

func (t ResetPasswordTokenDBTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t ResetPasswordTokenDBTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Columns returns the database table column names
func (s Template) Columns() []string {
	return TemplateColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Template) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "account":
			values[i] = s.Account
		case "created_at":
			values[i] = s.CreatedAt
		case "data_schema":
			values[i] = s.DataSchema
		case "description":
			values[i] = s.Description
		case "language":
			values[i] = s.Language
		case "locale":
			values[i] = s.Locale
		case "metadata":
			values[i] = s.Metadata
		case "name":
			values[i] = s.Name
		case "produces":
			values[i] = s.Produces
		case "static_metadata":
			values[i] = s.StaticMetadata
		case "title":
			values[i] = s.Title
		case "version":
			values[i] = s.Version
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s Template) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "account":
			values["account"] = s.Account
		case "created_at":
			values["created_at"] = s.CreatedAt
		case "data_schema":
			values["data_schema"] = s.DataSchema
		case "description":
			values["description"] = s.Description
		case "language":
			values["language"] = s.Language
		case "locale":
			values["locale"] = s.Locale
		case "metadata":
			values["metadata"] = s.Metadata
		case "name":
			values["name"] = s.Name
		case "produces":
			values["produces"] = s.Produces
		case "static_metadata":
			values["static_metadata"] = s.StaticMetadata
		case "title":
			values["title"] = s.Title
		case "version":
			values["version"] = s.Version
		}
	}
	return values
}

// Table returns the database table name
func (s TemplateDB) Table() string {
	return TemplateDBTable
}

// PKeyColumn returns the database table primary key column name
func (s TemplateDB) PKeyColumn() string {
	return TemplateDBPKeyColumn
}

// Columns returns the database table column names
func (s TemplateDB) Columns(withPKey bool) []string {
	if withPKey {
		return TemplateDBColumns
	}
	return TemplateDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s TemplateDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "account":
			values[i] = s.Account
		case "created_at":
			values[i] = s.CreatedAt
		case "data_schema":
			values[i] = s.DataSchema
		case "description":
			values[i] = s.Description
		case "language":
			values[i] = s.Language
		case "locale":
			values[i] = s.Locale
		case "metadata":
			values[i] = s.Metadata
		case "name":
			values[i] = s.Name
		case "produces":
			values[i] = s.Produces
		case "static_metadata":
			values[i] = s.StaticMetadata
		case "title":
			values[i] = s.Title
		case "version":
			values[i] = s.Version
		case "id":
			values[i] = s.ID
		case "internal_version":
			values[i] = s.InternalVersion
		case "etag":
			values[i] = s.ETag
		case "body":
			values[i] = s.BytesBody
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s TemplateDB) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "account":
			values["account"] = s.Account
		case "created_at":
			values["created_at"] = s.CreatedAt
		case "data_schema":
			values["data_schema"] = s.DataSchema
		case "description":
			values["description"] = s.Description
		case "language":
			values["language"] = s.Language
		case "locale":
			values["locale"] = s.Locale
		case "metadata":
			values["metadata"] = s.Metadata
		case "name":
			values["name"] = s.Name
		case "produces":
			values["produces"] = s.Produces
		case "static_metadata":
			values["static_metadata"] = s.StaticMetadata
		case "title":
			values["title"] = s.Title
		case "version":
			values["version"] = s.Version
		case "id":
			values["id"] = s.ID
		case "internal_version":
			values["internal_version"] = s.InternalVersion
		case "etag":
			values["etag"] = s.ETag
		case "body":
			values["body"] = s.BytesBody
		}
	}
	return values
}

func NewTemplateDBTableSchema() *TemplateDBTableSchema {
	t := TemplateDBTableSchema{}
	t.Account = NewColumn(&t, "account")
	t.CreatedAt = NewColumn(&t, "created_at")
	t.DataSchema = NewColumn(&t, "data_schema")
	t.Description = NewColumn(&t, "description")
	t.Language = NewColumn(&t, "language")
	t.Locale = NewColumn(&t, "locale")
	t.Metadata = NewColumn(&t, "metadata")
	t.Name = NewColumn(&t, "name")
	t.Produces = NewColumn(&t, "produces")
	t.StaticMetadata = NewColumn(&t, "static_metadata")
	t.Title = NewColumn(&t, "title")
	t.Version = NewColumn(&t, "version")
	t.ID = NewColumn(&t, "id")
	t.InternalVersion = NewColumn(&t, "internal_version")
	t.ETag = NewColumn(&t, "etag")
	t.BytesBody = NewColumn(&t, "body")
	return &t
}

type TemplateDBTableSchema struct {
	alias string
	Account Column
	CreatedAt Column
	DataSchema Column
	Description Column
	Language Column
	Locale Column
	Metadata Column
	Name Column
	Produces Column
	StaticMetadata Column
	Title Column
	Version Column
	ID Column
	InternalVersion Column
	ETag Column
	BytesBody Column
}

// Columns returns the database table column names
func (t TemplateDBTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return TemplateDBColumns
	}
	return TemplateDBDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t TemplateDBTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = TemplateDBDataColumns

	if withPKey {
		colList = TemplateDBColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t TemplateDBTableSchema) As(name string) *TemplateDBTableSchema {
	t.alias = name
	t.Account = NewColumn(&t, "account")
	t.CreatedAt = NewColumn(&t, "created_at")
	t.DataSchema = NewColumn(&t, "data_schema")
	t.Description = NewColumn(&t, "description")
	t.Language = NewColumn(&t, "language")
	t.Locale = NewColumn(&t, "locale")
	t.Metadata = NewColumn(&t, "metadata")
	t.Name = NewColumn(&t, "name")
	t.Produces = NewColumn(&t, "produces")
	t.StaticMetadata = NewColumn(&t, "static_metadata")
	t.Title = NewColumn(&t, "title")
	t.Version = NewColumn(&t, "version")
	t.ID = NewColumn(&t, "id")
	t.InternalVersion = NewColumn(&t, "internal_version")
	t.ETag = NewColumn(&t, "etag")
	t.BytesBody = NewColumn(&t, "body")
	return &t
}

func (t TemplateDBTableSchema) GetName() string {
	if t.alias == "" {
		return TemplateDBTable
	}
	return t.alias
}

func (t TemplateDBTableSchema) Sql() string {
	if t.alias == "" {
		return TemplateDBTable
	}
	return TemplateDBTable + " AS " + t.alias
}

func (t TemplateDBTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t TemplateDBTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Table returns the database table name
func (s UserDB) Table() string {
	return UserDBTable
}

// PKeyColumn returns the database table primary key column name
func (s UserDB) PKeyColumn() string {
	return UserDBPKeyColumn
}

// Columns returns the database table column names
func (s UserDB) Columns(withPKey bool) []string {
	if withPKey {
		return UserDBColumns
	}
	return UserDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s UserDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "created_at":
			values[i] = s.CreatedAt
		case "email":
			values[i] = s.Email
		case "enable_request_logging":
			values[i] = s.EnableRequestLogging
		case "firstname":
			values[i] = s.Firstname
		case "is_admin":
			values[i] = s.IsAdmin
		case "lastname":
			values[i] = s.Lastname
		case "username":
			values[i] = s.Username
		case "password":
			values[i] = s.Password
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s UserDB) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "created_at":
			values["created_at"] = s.CreatedAt
		case "email":
			values["email"] = s.Email
		case "enable_request_logging":
			values["enable_request_logging"] = s.EnableRequestLogging
		case "firstname":
			values["firstname"] = s.Firstname
		case "is_admin":
			values["is_admin"] = s.IsAdmin
		case "lastname":
			values["lastname"] = s.Lastname
		case "username":
			values["username"] = s.Username
		case "password":
			values["password"] = s.Password
		}
	}
	return values
}

func NewUserDBTableSchema() *UserDBTableSchema {
	t := UserDBTableSchema{}
	t.CreatedAt = NewColumn(&t, "created_at")
	t.Email = NewColumn(&t, "email")
	t.EnableRequestLogging = NewColumn(&t, "enable_request_logging")
	t.Firstname = NewColumn(&t, "firstname")
	t.IsAdmin = NewColumn(&t, "is_admin")
	t.Lastname = NewColumn(&t, "lastname")
	t.Username = NewColumn(&t, "username")
	t.Password = NewColumn(&t, "password")
	return &t
}

type UserDBTableSchema struct {
	alias string
	CreatedAt Column
	Email Column
	EnableRequestLogging Column
	Firstname Column
	IsAdmin Column
	Lastname Column
	Username Column
	Password Column
}

// Columns returns the database table column names
func (t UserDBTableSchema) Columns(withPKey bool) []string {
	if withPKey {
		return UserDBColumns
	}
	return UserDBDataColumns
}

// FQColumns returns the database table column names prefixed with the table alias
func (t UserDBTableSchema) FQColumns(withPKey bool) []string {
	var colList []string
    colList = UserDBDataColumns

	if withPKey {
		colList = UserDBColumns
	}

    var cols []string
	for _, col := range colList {
			cols = append(cols, t.GetName()+"."+col)
	}
	return cols
}

func (t UserDBTableSchema) As(name string) *UserDBTableSchema {
	t.alias = name
	t.CreatedAt = NewColumn(&t, "created_at")
	t.Email = NewColumn(&t, "email")
	t.EnableRequestLogging = NewColumn(&t, "enable_request_logging")
	t.Firstname = NewColumn(&t, "firstname")
	t.IsAdmin = NewColumn(&t, "is_admin")
	t.Lastname = NewColumn(&t, "lastname")
	t.Username = NewColumn(&t, "username")
	t.Password = NewColumn(&t, "password")
	return &t
}

func (t UserDBTableSchema) GetName() string {
	if t.alias == "" {
		return UserDBTable
	}
	return t.alias
}

func (t UserDBTableSchema) Sql() string {
	if t.alias == "" {
		return UserDBTable
	}
	return UserDBTable + " AS " + t.alias
}

func (t UserDBTableSchema) ToSql() (string, []interface{}, error) {
	return t.Sql(), nil, nil
}

func (t UserDBTableSchema) Select() squirrel.SelectBuilder {
	return squirrel.Select(t.Columns(true)...).From(t.Sql())
}

// Columns returns the database table column names
func (s Userinfo) Columns() []string {
	return UserinfoColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Userinfo) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "created_at":
			values[i] = s.CreatedAt
		case "email":
			values[i] = s.Email
		case "enable_request_logging":
			values[i] = s.EnableRequestLogging
		case "firstname":
			values[i] = s.Firstname
		case "is_admin":
			values[i] = s.IsAdmin
		case "lastname":
			values[i] = s.Lastname
		case "username":
			values[i] = s.Username
		}
	}
	return values
}

// ValuesMap returns the values map for a list of columns. If a column does not
// exits, the corresponding value is left empty
func (s Userinfo) ValuesMap(columns ...string) map[string]interface{} {
	values := make(map[string]interface{})
	for _, column := range columns {
		switch column {
		case "created_at":
			values["created_at"] = s.CreatedAt
		case "email":
			values["email"] = s.Email
		case "enable_request_logging":
			values["enable_request_logging"] = s.EnableRequestLogging
		case "firstname":
			values["firstname"] = s.Firstname
		case "is_admin":
			values["is_admin"] = s.IsAdmin
		case "lastname":
			values["lastname"] = s.Lastname
		case "username":
			values["username"] = s.Username
		}
	}
	return values
}

func NewDBSchema() *DBSchema {
	return &DBSchema{
		AccountDB: NewAccountDBTableSchema(),
		ApikeyDB: NewApikeyDBTableSchema(),
		Email: NewEmailTableSchema(),
		RenderLog: NewRenderLogTableSchema(),
		ResetPasswordTokenDB: NewResetPasswordTokenDBTableSchema(),
		TemplateDB: NewTemplateDBTableSchema(),
		UserDB: NewUserDBTableSchema(),
	}
}

type DBSchema struct {
	AccountDB *AccountDBTableSchema
	ApikeyDB *ApikeyDBTableSchema
	Email *EmailTableSchema
	RenderLog *RenderLogTableSchema
	ResetPasswordTokenDB *ResetPasswordTokenDBTableSchema
	TemplateDB *TemplateDBTableSchema
	UserDB *UserDBTableSchema
}

var Schema = NewDBSchema()

