// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// Document A final document. Can be returned by a rendering, but also send to render
// for a type conversion without rendering a template.
//
//
// swagger:model document
type Document struct {

	// Content
	Body string `json:"body,omitempty"`

	// The body attribute format. Can be 'text' or 'base64'. Default 'base64'
	BodyFormat string `json:"body-format,omitempty"`

	// metadata
	Metadata Metadata `json:"metadata,omitempty"`

	// A list of non-blocking errors that occured during rendering
	RenderErrors []RenderError `json:"render-errors"`

	// The document mimetype
	Type string `json:"type,omitempty"`
}

// Validate validates this document
func (m *Document) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateMetadata(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRenderErrors(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Document) validateMetadata(formats strfmt.Registry) error {

	if swag.IsZero(m.Metadata) { // not required
		return nil
	}

	if err := m.Metadata.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("metadata")
		}
		return err
	}

	return nil
}

func (m *Document) validateRenderErrors(formats strfmt.Registry) error {

	if swag.IsZero(m.RenderErrors) { // not required
		return nil
	}

	for i := 0; i < len(m.RenderErrors); i++ {

		if err := m.RenderErrors[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("render-errors" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *Document) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Document) UnmarshalBinary(b []byte) error {
	var res Document
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
