package models

import (
	"time"

	"github.com/Masterminds/squirrel"
	"orus.io/orus-io/go-orusapi/database"

	"orus.io/orus-io/rednerd/utils"
)

func NewResetPasswordToken(db database.SQLHelper, username string) (string, error) {
	token := utils.RandomString(32)
	if _, err := db.Exec(
		squirrel.Insert("reset_password_token").
			Columns("username", "created_at", "token").
			Values(username, time.Now().UTC(), token),
	); err != nil {
		return "", err
	}

	return token, nil
}

// dbtable:"reset_password_token" dbpkey:"token"
type ResetPasswordTokenDB struct {
	Username  string    `db:"username"`
	CreatedAt time.Time `db:"created_at"`
	Token     string    `db:"token"`
}
